<?php
// $Id: cck_field_rename.admin.inc,v 1.5 2010/09/26 21:27:53 thenicespider Exp $

/**
 * @file
 * Administration process forms of cck_field_rename module.
 */
 
/**
 * Menu callback;
 */
 
function cck_field_rename_action() {
  $form = array();
    
  // Generate the form
  $form['cck_field_rename_action'] = array(
    '#type' => 'fieldset',
    '#weight' => -30,
    '#title' => t('Basic settings (Please make a DATABASE BACKUP first for preventive!)'),
    '#collapsible' => FALSE,
    '#collapsed' => FALSE    
  );
  
  $sql = " SELECT field_name FROM {content_node_field} ORDER BY field_name";
  $results = db_query($sql);
  
  while ($data = db_fetch_object($results)) {
    $cck_fields[$data->field_name]= $data->field_name;  
  }
  
  $form['cck_field_rename_action']['cck_field_rename_source'] = array(
    '#type' => 'select',
    '#title' => t('Select CCK field'),
    '#options' => $cck_fields,
    '#default_value' => variable_get('cck_field_rename_source', ''),
  );    
  
  $form['cck_field_rename_action']['cck_field_rename_target'] = array(
    '#type' => 'textfield',
    '#title' => t('New field name'),
    '#default_value' => variable_get('cck_field_rename_target', ''),
  ); 
  
  $form['cck_field_rename_action']['cck_field_rename_process'] = array(
      '#type' => 'submit',
      '#value' => t('Rename field'),
      '#submit' => array('cck_field_rename_process'),
    );
  return $form;
  //return system_settings_form($form);
}

//Rename the selected field
function cck_field_rename_process() {
  $field_source = addslashes(strip_tags($_REQUEST['cck_field_rename_source']));
  $field_target = addslashes(strip_tags($_REQUEST['cck_field_rename_target']));
	
	//get content type
  $sql = " SELECT type_name FROM {content_node_field_instance} WHERE field_name = '%s'";
  $results = db_query($sql, $field_source);
  $data = db_fetch_object($results);
  $cck_content_type = $data->type_name;
  
  //get field type
  $sql = " SELECT type FROM {content_node_field} WHERE field_name = '%s'";
  $results = db_query($sql, $field_source);
  $data = db_fetch_object($results);
  $cck_field_type = $data->type;
	
	//check supported type
	$supported_field_type = array('text','number_integer','number_float','number_decimal','filefield',
	  'nodereference','date');
	if (!in_array($cck_field_type,$supported_field_type)) {
    drupal_set_message(t("Field type not yet supported (please report this issue): $cck_field_type."));
    return;
	}
	
  if (substr($field_target,0,6) != 'field_') {
    drupal_set_message(t("Sorry, new field name must starting with 'field_' (i.e: field_myfield)."));
    return;  
  }
  
	//if multigroup
	$sql = " SELECT group_type FROM {content_group_fields} cgf "
	      ." INNER JOIN {content_group} cg ON cg.type_name= cgf.type_name AND cg.group_name=cgf.group_name"
	      ." WHERE field_name = '%s'";
  $results = db_query($sql, $field_source);
  $data = db_fetch_object($results);
	$group_type = $data->group_type;
  
  //field
  $table_name       = 'content_type_'.$cck_content_type;
	
	if ($group_type == 'multigroup') {
	   db_rename_table($ret, 'content_'.$field_source, 'content_'.$field_target);
		 $table_name = 'content_'.$field_target;
  }
	
  $field = content_fields($field_source);
	$field_info = content_database_info($field);

	$field_type = $field_info['columns']['value']['type'];
	$field_size = $field_info['columns']['value']['size'];
	$field_prec = $field_info['columns']['value']['precision'];
	$field_scal = $field_info['columns']['value']['scale'];
	$field_leng = $field_info['columns']['value']['length'];
	
	//print_r($field_info['columns']['value']); 
	//return;
	
	switch ($cck_field_type) {
    case 'text':
      db_change_field($ret, $table_name, $field_source.'_value', $field_target.'_value', 
        array('type' => $field_type, 'size' => $field_size,'not null' => FALSE));
      break;
      
    case 'number_integer':
	    db_change_field($ret, $table_name, $field_source.'_value', $field_target.'_value', 
        array('type' => $field_type, 'size' => 'normal','not null' => FALSE));
      break;
      
    case 'number_float':
		  db_change_field($ret, $table_name, $field_source.'_value', $field_target.'_value', 
        array('type' => $field_type, 'size' => 'normal','not null' => FALSE));
      break;
      
    case 'number_decimal':
		  db_change_field($ret, $table_name, $field_source.'_value', $field_target.'_value', 
        array('type' => $field_type, 'size' => 'normal','not null' => FALSE, 
		  	  'precision' => $field_prec,'scale' => $field_scal ));
		  break;
      
    case 'filefield':
		  db_change_field($ret, $table_name, $field_source.'_fid', $field_target.'_fid', 
        array('type' => 'int', 'size' => 'normal','not null' => FALSE));			
		  db_change_field($ret, $table_name, $field_source.'_list', $field_target.'_list', 
        array('type' => 'int', 'size' => 'tiny','not null' => FALSE));			
		  db_change_field($ret, $table_name, $field_source.'_data', $field_target.'_data', 
        array('type' => 'text', 'size' => 'normal','not null' => FALSE));
      break;
      
    case 'nodereference':
		  db_change_field($ret, $table_name, $field_source.'_nid', $field_target.'_nid', 
        array('type' => 'int', 'size' => 'normal','not null' => FALSE));
		  break;
    
		case 'date':
      db_change_field($ret, $table_name, $field_source.'_value', $field_target.'_value', 
        array('type' => $field_type, 'size' => 'normal', 'not null' => FALSE, 'length' => $field_leng));
      break;
	}
	
	
  //content_node_field_instance
  $sql = " UPDATE {content_node_field_instance} SET field_name = '%s' WHERE field_name = '%s'";
  db_query($sql, $field_target, $field_source);
  
  //content_group_fields
  $sql = " UPDATE {content_group_fields} SET field_name = '%s' WHERE field_name = '%s'";
  db_query($sql, $field_target, $field_source);
  
  //content_node_field
  $sql = " UPDATE {content_node_field} SET field_name = '%s' WHERE field_name = '%s'";
  db_query($sql, $field_target, $field_source);
  
  db_query("TRUNCATE TABLE {cache_content}");
	drupal_flush_all_caches();
  
  //Results
  drupal_set_message(t(
    " Content type: $cck_content_type<br />"
   ." Rename '$field_source' to '$field_target'<br /><br />"
	 ." You may need to perform 'Performance-Clear cached data' if manage fields not run properly."));
  
  
  return;
}
